﻿Imports System.Text.RegularExpressions

Module modCaptureTester
   Public Sub Main()
      Dim pattern As String = "^[^<>]*" & _
                              "(" + "((?'Open'<)[^<>]*)+" & _
                              "((?'Close-Open'>)[^<>]*)+" + ")*" & _
                              "(?(Open)(?!))$"
      Dim input As String = "asd<a<b>c><m<n>o<xyz>>eew"
      Dim rgx As New Regex(pattern) '
      Dim m As Match = Regex.Match(input, pattern)
      If m.Success Then
         Console.WriteLine("Input: ""{0}"" " & Lf & "Match: ""{1}""", _
                            input, m)
         Dim grpCtr As Integer = 0
         For Each grp As Group In m.Groups
            Console.WriteLine("   Group {0}: {1}", grpCtr, grp.Value)
            grpCtr += 1
            Dim capCtr As Integer = 0
            For Each cap As Capture In grp.Captures
               Console.WriteLine("      Capture {0}: {1}", capCtr, cap.Value)
               capCtr += 1
            Next
         Next
      Else
         Console.WriteLine("Match failed.")
      End If
   End Sub
End Module
