Imports System.Text
Imports System.Text.RegularExpressions

Public Class clsGroupInfo
   Inherits clsSegmentInfo
   Implements INodeContent(Of clsGroupInfo)

   Public Overloads Function Node(ByVal Value As clsNode(Of clsGroupInfo)) _
         As INodeContent(Of clsGroupInfo) _
         Implements INodeContent(Of clsGroupInfo).Node
      _Node = Value
      Return Me
   End Function
   Public Overloads Function Node() As clsNode(Of clsGroupInfo) _
         Implements INodeContent(Of clsGroupInfo).Node
      Return DirectCast(_Node, clsNode(Of clsGroupInfo))
   End Function
   Public Name As String = ""
End Class

Public Class clsSegmentInfo
   Implements INodeContent(Of clsSegmentInfo)

   Protected _Node As Object
   Public Function Node(ByVal Value As clsNode(Of clsSegmentInfo)) _
         As INodeContent(Of clsSegmentInfo) _
         Implements INodeContent(Of clsSegmentInfo).Node
      _Node = Value
      Return Me
   End Function
   Public Function Node() As clsNode(Of clsSegmentInfo) _
         Implements INodeContent(Of clsSegmentInfo).Node
      Return DirectCast(_Node, clsNode(Of clsSegmentInfo))
   End Function

   Protected _Index, _RelativeIndex, _Length As Integer
   Protected _TextBase As New StringBuilder

   Public Sub New()
   End Sub
   Public Function SetTextbase(ByVal TextBase As StringBuilder) As clsSegmentInfo
      _TextBase = TextBase
      Return Me
   End Function
   Public Function TextBase() As StringBuilder
      Return _TextBase
   End Function

   Public Function SetIndex(ByVal Value As Integer) As clsSegmentInfo
      _Index = Value
      Return Me
   End Function
   Public ReadOnly Property Index() As Integer
      Get
         Return _Index
      End Get
   End Property

   Public Function SetRelativeIndex(ByVal Value As Integer) As clsSegmentInfo
      _RelativeIndex = Value
      Return Me
   End Function
   Public ReadOnly Property RelativeIndex() As Integer
      Get
         Return _RelativeIndex
      End Get
   End Property

   Public Function SetLength(ByVal Value As Integer) As clsSegmentInfo
      _Length = Value
      Return Me
   End Function
   Public ReadOnly Property Length() As Integer
      Get
         Return _Length
      End Get
   End Property

   Public ReadOnly Property Value() As String
      Get
         Return _TextBase.ToString(_Index, _Length)
      End Get
   End Property


   Public ReadOnly Property Value(ByVal Index As Integer, ByVal Length As Integer) As String
      Get
         Return _TextBase.ToString(_Index + Index, Length)
      End Get
   End Property

End Class
